#include <amxmodx>
#include <amxmisc>
#include <sqlx>
#include <cstrike>
#include <hamsandwich>
#include <zombieplague>
#include <fun>

#pragma dynamic 32768 

#define is_valid_player(%1) (1 <= %1 <= 32) 

new Handle:g_SqlTuple

// Register System
new bool:g_LoggedIn[33]
new g_RegisterSelection[33]

new g_szTempName[33][100]
new g_szTempPassWord[33][100]

// Stats System ( Points )
new g_RankTempID
new g_Top10TempID

new g_TotalPoints[33]

new g_HumanKillsZombiePoints[33]
new g_HumanKillsNemesisPoints[33]
new g_SurvivorKillsZombiePoints[33]
new g_HumanKillsZombieKnifePoints[33]

new g_ZombieInfectsHumanPoints[33]
new g_NemesisKillsHuman[33]
new g_ZombieKillsSurvivor[33]
new g_ZombieKillsHumanPS[33]

new g_AP[33]
new g_DonateID[33]

// Achievements
new g_Minutes[33]
new g_ZombieKillCount1[33]
new g_ZombieKillCount2[33]
new g_ZombieKillCount3[33]
new g_ZombieHSKillCount[33]
new g_Rounds[33]
new g_KillInfectCount1[33]
new g_KillInfectCount2[33]
new g_KillInfectCount3[33]
new g_gotKillInfectCount[33]
new g_nemeKillCountKnife[33]
new g_killzombieknife[33]
new g_winsurvivor[33]
new g_winnemesis[33]
new g_killsurvivorplague[33]
new g_killnemesisplague[33]
new g_kill600survivor[33]
new g_kill600nemesis[33]
new g_InfectionBombCount[33]
new g_SprayCount[33]
new g_awpkills[33]
new g_infectinrowcount1[33]
new g_infectinrowcount2[33]
new g_zmkillrowcount1[33]
new g_zmkillrowcount2[33]
new g_lasthumankillall[33]

// Cvars
new cvHost, cvUserName, cvPassWord, cvDbName

public plugin_init()
{
	register_plugin("zp_rabs by mottzi","2.1","mottzi")
	
	cvHost = register_cvar("zp_rabs_sql_host", "")
	cvUserName = register_cvar("zp_rabs_sql_username", "")
	cvPassWord = register_cvar("zp_rabs_sql_password", "")
	cvDbName = register_cvar("zp_rabs_sql_database", "")
	
	makeTuple()
	
	register_clcmd("say /login", "menuRegister") 
	
	register_clcmd("jointeam", "menuRegister")
	register_event("TeamInfo", "joinTeamOldMenu", "a")
	
	register_clcmd("say /top10", "cmdTop10")
	register_clcmd("say /rank", "cmdRank")
	register_clcmd("say /zmtop10", "cmdTop10")
	register_clcmd("say /zmrank", "cmdRank")
	
	register_clcmd("say /statistics", "menuStats")
	register_clcmd("say /stats", "menuStats")
	
	register_clcmd("say /achievements", "menuAchvs")
	register_clcmd("say /achvs", "menuAchvs")
	register_clcmd("say /achv", "menuAchvs")
	
	register_clcmd("Username", "cmdUsername")
	register_clcmd("szPassword", "cmdPw")
	
	register_clcmd("takeAmount", "cmdTakeAmount")
	register_clcmd("saveAmount", "cmdSaveAmount")
	register_clcmd("donate", "cmdDonate")
	
	register_clcmd("say /bank", "menuBank")
	register_clcmd("say_team /bank", "menuBank")
	
	register_event("DeathMsg", "DeathMsg", "a")
	register_event("23", "cmdNewSpray", "a", "1=112") 
	
	RegisterHam( Ham_Item_AddToPlayer, "weapon_hegrenade", "AddGrenadeToPlayer" );
	
	createTable()
	
	register_logevent("cmdRoundStart", 2, "1=Round_Start")
	
	set_task(60.0, "increaseMinutes", .flags="b")
	set_task(120.0, "cmdHelpCommands", .flags="b")
	set_task(150.0, "cmdHelpCommands2", .flags="b")
}

public makeTuple()
{
	new Host[100], UserName[20], PassWord[20], DbName[100]
	
	get_pcvar_string(cvHost, Host, 99)
	get_pcvar_string(cvUserName, UserName, 19)
	get_pcvar_string(cvPassWord, PassWord, 19)
	get_pcvar_string(cvDbName, DbName, 99)
	
	g_SqlTuple = SQL_MakeDbTuple(Host, UserName, PassWord, DbName)
}

public cmdHelpCommands()
{
	client_print(0, print_chat, "[ZP-RABS] Say '/bank' to open the Bank Menu")
	client_print(0, print_chat, "[ZP-RABS] Say '/achvs' or '/achievements' to open the Achievements Menu")
	client_print(0, print_chat, "[ZP-RABS] Say '/stats' or '/statistics' to see the Statistics")
}

public cmdHelpCommands2()
{
	client_print(0, print_chat, "[ZP-RABS] Say '/zmtop10' to see the Top10 Players on this Server")
	client_print(0, print_chat, "[ZP-RABS] Say '/zmrank' to see your Rank")
	client_print(0, print_chat, "[ZP-RABS] Achievements, Bank, Stats and Register System are made by Mottzi")
}

public joinTeamOldMenu()
{
	new id = read_data(1)
	new user_team[32]
	
	read_data(2, user_team, 31)    
	
	if(!is_user_connected(id))
		return PLUGIN_HANDLED   
	
	if(g_LoggedIn[id])
		return PLUGIN_HANDLED
	
	switch(user_team[0])
	{
		case 'C':  
		{
			menuRegister(id)
		}
		case 'T':
		{
			menuRegister(id)
		}
	}
	
	return PLUGIN_HANDLED
}

public AddGrenadeToPlayer( iEnt, id )
{
	if(is_user_connected(id) && zp_get_user_zombie(id)) 
	{
		g_InfectionBombCount[id]++
		
		if(g_InfectionBombCount[id] == 300)
		{
			client_print(id, print_chat, "[Achievements] You unlocked ^"Bomber^"")
		}
	}
}

public cmdNewSpray()
{
	new sprayid = read_data(2)	// Spray Owner
	
	g_SprayCount[sprayid]++
	
	if(g_SprayCount[sprayid] == 300)
	{
		client_print(sprayid, print_chat, "[Achievements] You unlocked ^"Art of War^"")
	}
}

public menuAchvs(id)
{
	new achvsMenu = menu_create("Achievements", "menuAchvsHandler")
	new szTitle[100]
	
	// 1
	if(g_Minutes[id] >= 600)
		formatex(szTitle, 99, "<3^n\r[Unlocked]\w Play for 600 Minutes^n")
	else 
		formatex(szTitle, 99, "<3^nPlay for 600 Minutes \y(\r%i Minutes\y)^n", g_Minutes[id])
	
	menu_additem(achvsMenu, szTitle, "1")
	
	// 2
	if(g_ZombieHSKillCount[id] >= 600)
		formatex(szTitle, 99, "Boom! Headshot^n\r[Unlocked]\w Kill 600 Zombies or Nemesises with headshots^n")
	else
		formatex(szTitle, 99, "Boom! Headshot^nKill 600 Zombies or Nemesises with headshots \y(\r%i Kills\y)^n", g_ZombieHSKillCount[id])
	
	menu_additem(achvsMenu, szTitle, "2")
	
	// 3
	if(g_Rounds[id] >= 3000)
		formatex(szTitle, 99, "To the Extreme^n\r[Unlocked]\w Play a total of 3,000 Rounds over all your time played^n")
	else
		formatex(szTitle, 99, "To the Extreme^nPlay a total of 3,000 Rounds over all your time played \y(\r%i Rounds\y)^n", g_Rounds[id])
	
	menu_additem(achvsMenu, szTitle, "3")
	
	// 4
	if(g_ZombieKillCount1[id] >= 100)
		formatex(szTitle, 99, "Zombies are Better Off Dead^n\r[Unlocked]\w Kill 100 Zombies^n")
	else
		formatex(szTitle, 99, "Zombies are Better Off Dead^nKill 100 Zombies \y(\r%i Kills\y)^n", g_ZombieKillCount1[id])
	
	menu_additem(achvsMenu, szTitle, "4")
	
	// 5
	if(g_ZombieKillCount2[id] >= 600)
		formatex(szTitle, 99, "Zombie Assassinator^n\r[Unlocked]\w Kill 600 Zombies^n")
	else
		formatex(szTitle, 99, "Zombie Assassinator^nKill 600 Zombies \y(\r%i Kills\y)^n", g_ZombieKillCount2[id])
	
	menu_additem(achvsMenu, szTitle, "5")
	
	// 6
	if(g_ZombieKillCount2[id] >= 600)
		formatex(szTitle, 99, "Expert Zombie Killer^n\r[Unlocked]\w Kill 1000 Zombies^n")
	else
		formatex(szTitle, 99, "Expert Zombie Killer^nKill 1000 Zombies \y(\r%i Kills\y)^n", g_ZombieKillCount3[id])
	
	menu_additem(achvsMenu, szTitle, "6")
	
	
	// 7
	if(g_KillInfectCount1[id] >= 200)
		formatex(szTitle, 99, "Mmmmm Brains...^n\r[Unlocked]\w Infect/Kill 200 Humans^n")
	else
		formatex(szTitle, 99, "Mmmmm Brains...^nInfect/Kill 200 Humans \y(\r%i Kills/Infects\y)^n", g_KillInfectCount1[id])
	
	menu_additem(achvsMenu, szTitle, "7")
	
	// 8
	if(g_KillInfectCount2[id] >= 1200)
		formatex(szTitle, 99, "Phoenix Rising^n\r[Unlocked]\w Infect/Kill 1200 Humans^n")
	else
		formatex(szTitle, 99, "Phoenix Rising^nInfect/Kill 1200 Humans \y(\r%i Kills/Infects\y)^n", g_KillInfectCount2[id])
	
	menu_additem(achvsMenu, szTitle, "8")
	
	// 9
	if(g_KillInfectCount3[id] >= 2000)
		formatex(szTitle, 99, "Infected^n\r[Unlocked]\w Infect/Kill 2000 Humans^n")
	else
		formatex(szTitle, 99, "Infected^nInfect/Kill 2000 Humans \y(\r%i Kills/Infects\y)^n", g_KillInfectCount3[id])
	
	menu_additem(achvsMenu, szTitle, "9")
	
	// 10
	if(g_gotKillInfectCount[id] >= 1000)
		formatex(szTitle, 99, "Enemies With Benefits^n\r[Unlocked]\w Get Infected/Killed by a Zombie 1,000 times^n")
	else
		formatex(szTitle, 99, "Enemies With Benefits^nGet Infected/Killed by a Zombie 1,000 times \y(\r%i Kills/Infects\y)^n", g_gotKillInfectCount[id])
	
	menu_additem(achvsMenu, szTitle, "10")
	
	// 11
	if(g_nemeKillCountKnife[id] >= 10)
		formatex(szTitle, 99, "Nerves of Steel^n\r[Unlocked]\w Kill 10 Nemesises with a Knife^n")
	else
		formatex(szTitle, 99, "Nerves of Steel^nKill 10 Nemesises with a Knife \y(\r%i Kills\y)^n", g_nemeKillCountKnife[id])
	
	menu_additem(achvsMenu, szTitle, "11")
	
	// 12
	if(g_killzombieknife[id] >= 200)
		formatex(szTitle, 99, "The Legend^n\r[Unlocked]\w Kill 200 Zombies with a Knife^n")
	else
		formatex(szTitle, 99, "The Legend^nKill 200 Zombies with a Knife \y(\r%i Kills\y)^n", g_killzombieknife[id])
	
	menu_additem(achvsMenu, szTitle, "12")
	
	// 13
	if(g_winsurvivor[id] >= 10)
		formatex(szTitle, 99, "Survivor^n\r[Unlocked]\w Win 10 rounds as Survivor in Survivor Mode^n")
	else
		formatex(szTitle, 99, "Survivor^nWin 10 rounds as Survivor in Survivor Mode \y(\r%i wins\y)^n", g_winsurvivor[id])
	
	menu_additem(achvsMenu, szTitle, "13")
	
	// 14
	if(g_winnemesis[id] >= 10)
		formatex(szTitle, 99, "Nemesis^n\r[Unlocked]\w Win 10 rounds as Nemesis as Nemesis Mode^n")
	else
		formatex(szTitle, 99, "Nemesis^nWin 10 rounds as Nemesis in Nemesis Mode \y(\r%i wins\y)^n", g_winnemesis[id])
	
	menu_additem(achvsMenu, szTitle, "14")
	
	// 15
	if(g_killsurvivorplague[id] >= 300)
		formatex(szTitle, 99, "Ninja^n\r[Unlocked]\w Kill 300 Survivors in Plague Mode^n")
	else
		formatex(szTitle, 99, "Ninja^nKill 300 Survivors in Plague Mode \y(\r%i Kills\y)^n", g_killsurvivorplague[id])
	
	menu_additem(achvsMenu, szTitle, "15")
	
	// 16
	if(g_killnemesisplague[id] >= 300)
		formatex(szTitle, 99, "Think Fast!^n\r[Unlocked]\w Kill 300 Nemesises's in Plague Mode^n")
	else
		formatex(szTitle, 99, "Think Fast!^nKill 300 Nemesises in Plague Mode \y(\r%i Kills\y)^n", g_killnemesisplague[id])
	
	menu_additem(achvsMenu, szTitle, "16")
	
	// 17
	if(g_kill600survivor[id] >= 600)
		formatex(szTitle, 99, "Heartbreaker^n\r[Unlocked]\w Kill 600 Survivors^n")
	else
		formatex(szTitle, 99, "Heartbreaker^nKill 600 Survivors \y(\r%i Kills\y)^n", g_kill600survivor[id])
	
	menu_additem(achvsMenu, szTitle, "17")
	
	// 18
	if(g_kill600nemesis[id] >= 600)
		formatex(szTitle, 99, "Rejected^n\r[Unlocked]\w Kill 600 Nemesises^n")
	else
		formatex(szTitle, 99, "Rejected^nKill 600 Nemesises \y(\r%i Kills\y)^n", g_kill600nemesis[id])
	
	menu_additem(achvsMenu, szTitle, "18")
	
	// 19
	if(g_InfectionBombCount[id] >= 300)
		formatex(szTitle, 99, "Bomber^n\r[Unlocked]\w Buy 300 Infection Bombs^n")
	else
		formatex(szTitle, 99, "Bomber^nBuy 300 Infection Bombs \y(\r%i Bombs\y)^n", g_InfectionBombCount[id])
	
	menu_additem(achvsMenu, szTitle, "19")
	
	// 20
	if(g_SprayCount[id] >= 300)
		formatex(szTitle, 99, "Art of War^n\r[Unlocked]\w Spray 300 decals over all your time played^n")
	else
		formatex(szTitle, 99, "Art of War^nSpray 300 decals over all your time played \y(\r%i Sprays\y)^n", g_SprayCount[id])
	
	menu_additem(achvsMenu, szTitle, "20")
	
	// 21
	if(g_awpkills[id] >= 200)
		formatex(szTitle, 99, "Perfectionist^n\r[Unlocked]\w Kill 200 Zombies with an AWP Sniper Rifle^n")
	else
		formatex(szTitle, 99, "Perfectionist^nKill 200 Zombies with an AWP Sniper Rifle \y(\r%i Kills\y)^n", g_awpkills[id])
	
	menu_additem(achvsMenu, szTitle, "21")
	
	// 22
	if(g_infectinrowcount1[id] >= 5)
		formatex(szTitle, 99, "Bulletproof^n\r[Unlocked]\w Infect 5 Humans in 1 Round^n")
	else
		formatex(szTitle, 99, "Bulletproof^nInfect 5 Humans in 1 Round \y(\r%i Infects\y)^n", g_infectinrowcount1[id])
	
	menu_additem(achvsMenu, szTitle, "22")
	
	// 23
	if(g_infectinrowcount2[id] >= 10)
		formatex(szTitle, 99, "Angel of Death^n\r[Unlocked]\w Infect 10 Humans in 1 Round^n")
	else
		formatex(szTitle, 99, "Angel of Death^nInfect 5 Humans in 10 Round \y(\r%i Infects\y)^n", g_infectinrowcount2[id])
	
	menu_additem(achvsMenu, szTitle, "23")
	
	// 24
	if(g_zmkillrowcount1[id] >= 5)
		formatex(szTitle, 99, "Flyswatter^n\r[Unlocked]\w Kill 5 Zombies in 1 Round^n")
	else
		formatex(szTitle, 99, "Flyswatter^nKill 5 Zombies in 1 Round \y(\r%i Kills\y)^n", g_zmkillrowcount1[id])
	
	menu_additem(achvsMenu, szTitle, "24")
	
	// 25
	if(g_zmkillrowcount1[id] >= 10)
		formatex(szTitle, 99, "Sureshot^n\r[Unlocked]\w Kill 10 Zombies in 1 Round^n")
	else
		formatex(szTitle, 99, "Sureshot^nKill 10 Zombies in 1 Round \y(\r%i Kills\y)^n", g_zmkillrowcount2[id])
	
	menu_additem(achvsMenu, szTitle, "24")
	
	// 26
	if(g_lasthumankillall[id] >= 1)
		formatex(szTitle, 99, "Lone Wolf^n\r[Unlocked]\w Be the Last Human Standing and Kill all Zombies^n")
	else
		formatex(szTitle, 99, "Lone Wolf^nBe the Last Human Standing and Kill all Zombies^n")
	
	menu_additem(achvsMenu, szTitle, "25")
	
	
	menu_setprop(achvsMenu, MPROP_EXIT, MEXIT_ALL)
	menu_setprop(achvsMenu, MPROP_PERPAGE, 3)
	
	menu_display(id, achvsMenu, 0)
}

public menuAchvsHandler(id, menu, item) {}

public increaseMinutes()
{
	new players[32], pnum, tempid
	get_players(players, pnum)
	
	for(new i; i<pnum; i++)
	{
		tempid = players[i]
		new CsTeams:team = cs_get_user_team(tempid)
		
		if(team != CS_TEAM_SPECTATOR && team != CS_TEAM_UNASSIGNED)
		{
			g_Minutes[tempid]++
			
			if(g_Minutes[tempid] == 600)
			{
				client_print(tempid, print_chat, "[Achievements] You unlocked ^"<3^"")
			}
		}
		
		updateTableStats(tempid)
	}
}

public cmdRoundStart()
{
	new players[32], pnum, tempid
	get_players(players, pnum)
	
	for(new i; i<pnum; i++)
	{
		tempid = players[i]
		new CsTeams:team = cs_get_user_team(tempid)
		
		if(team != CS_TEAM_SPECTATOR && team != CS_TEAM_UNASSIGNED)
		{
			g_Rounds[tempid]++
			
			if(g_Rounds[tempid] == 3000)
			{
				client_print(tempid, print_chat, "[Achievements] You unlocked ^"To the Extreme^"")
			}
		}
		
		if(g_LoggedIn[tempid])
		{
			// Infect in round count (reset)
			if(g_infectinrowcount1[tempid] != 5)  g_infectinrowcount1[tempid] = 0
			if(g_infectinrowcount2[tempid] != 10) g_infectinrowcount2[tempid] = 0
			
			if(g_zmkillrowcount1[tempid] != 5)  g_zmkillrowcount1[tempid] = 0
			if(g_zmkillrowcount2[tempid] != 10) g_zmkillrowcount2[tempid] = 0
		}
	}
}

public createTable()
{
	new szQuery[2048]
	new len
	
	len += format(szQuery[len], 2048,"CREATE TABLE IF NOT EXISTS zp_rabs(")
	len += format(szQuery[len], 2048-len,"username VARCHAR(100), ")
	len += format(szQuery[len], 2048-len,"password VARCHAR(100), ")
	len += format(szQuery[len], 2048-len,"totalpoints INT(11), ")
	len += format(szQuery[len], 2048-len,"hkzpoints INT(11), ")
	len += format(szQuery[len], 2048-len,"hknpoints INT(11), ")
	len += format(szQuery[len], 2048-len,"skzpoints INT(11), ")
	len += format(szQuery[len], 2048-len,"hkzknifepoints INT(11), ")
	len += format(szQuery[len], 2048-len,"zihpoints INT(11), ")
	len += format(szQuery[len], 2048-len,"nkhpoints INT(11), ")
	len += format(szQuery[len], 2048-len,"zkspoints INT(11), ")
	len += format(szQuery[len], 2048-len,"zkhpspoints INT(11), ")
	len += format(szQuery[len], 20480-len,"ammopacks INT(11), ")
	len += format(szQuery[len], 2048-len,"minutesplayed INT(11), ")
	len += format(szQuery[len], 2048-len,"zombiekills1 INT(11), ")
	len += format(szQuery[len], 2048-len,"zombiekills2 INT(11), ")
	len += format(szQuery[len], 2048-len,"zombiekills3 INT(11), ")
	len += format(szQuery[len], 2048-len,"zombiehskills INT(11), ")
	len += format(szQuery[len], 2048-len,"rounds INT(11), ")
	len += format(szQuery[len], 2048-len,"humankillinfect1 INT(11), ")
	len += format(szQuery[len], 2048-len,"humankillinfect2 INT(11), ")
	len += format(szQuery[len], 2048-len,"humankillinfect3 INT(11), ")
	len += format(szQuery[len], 2048-len,"gotkilledinfected INT(11), ")
	len += format(szQuery[len], 2048-len,"nemekillknife INT(11), ")
	len += format(szQuery[len], 2048-len,"zombiekillknife INT(11), ")
	len += format(szQuery[len], 2048-len,"winsurvivor INT(11), ")
	len += format(szQuery[len], 2048-len,"winnemesis INT(11), ")
	len += format(szQuery[len], 2048-len,"ninja INT(11), ")
	len += format(szQuery[len], 2048-len,"thinkfast INT(11), ")
	len += format(szQuery[len], 2048-len,"kill600survivor INT(11), ")
	len += format(szQuery[len], 2048-len,"kill600nemesis INT(11), ")
	len += format(szQuery[len], 2048-len,"infectionbomb INT(11), ")
	len += format(szQuery[len], 2048-len,"sprays INT(11), ")
	len += format(szQuery[len], 2048-len,"awpkills INT(11), ")
	len += format(szQuery[len], 2048-len,"infectround1 INT(11), ")
	len += format(szQuery[len], 2048-len,"infectround2 INT(11), ")
	len += format(szQuery[len], 2048-len,"zmkillrow1 INT(11), ")
	len += format(szQuery[len], 2048-len,"zmkillrow2 INT(11), ")
	len += format(szQuery[len], 2048-len,"lasthumankillall INT(11))")
	
	SQL_ThreadQuery(g_SqlTuple,"createTableThread", szQuery)
}

public createTableThread(FailState,Handle:Query,Error[],Errcode,Data[],DataSize)
{
	if(FailState == TQUERY_CONNECT_FAILED)
		return set_fail_state("Could not connect to SQL database.")
	else if(FailState == TQUERY_QUERY_FAILED)
		return set_fail_state("Query failed.")
	
	if(Errcode)
		return log_amx("Error on query: %s",Error)
	
	return PLUGIN_CONTINUE
}

public DeathMsg()
{
	new killer = read_data(1)
	new victim = read_data(2)
	new hs = read_data(3)
	
	if(!g_LoggedIn[killer]) return PLUGIN_HANDLED
	
	// Suicide
	if(killer == victim) return PLUGIN_HANDLED
	
	if(is_valid_player(killer) && is_valid_player(victim))
	{
		// HUMAN STATISTICS
		
		// Human kills Zombie
		if(is_hkz_kill(killer, victim))
		{
			g_TotalPoints[killer] += 6
			g_HumanKillsZombiePoints[killer] += 6
			
			client_print(killer, print_chat, "[Status] You just got 6 Points for killing a Zombie.")
			
			
			// Achievements
			
			if(zp_get_user_last_human(killer) && zp_get_user_last_zombie(victim))
			{
				g_lasthumankillall[killer]++
				if(g_lasthumankillall[killer] == 1)
				{
					client_print(killer, print_chat, "[Achievements] You unlocked ^"Lone Wolf^"")
				}
			}
			
			new weapon = get_user_weapon(killer)
			if(weapon == CSW_KNIFE)
			{
				if(g_killzombieknife[killer] != 200)
				{
					g_killzombieknife[killer]++
					
					if(g_killzombieknife[killer] == 200)
					{
						client_print(killer, print_chat, "[Achievements] You unlocked ^"The Legend^"")
					}
				}
			}
			
			if(weapon == CSW_AWP)
			{
				if(g_awpkills[killer] != 200)
				{
					g_awpkills[killer]++
					
					if(g_awpkills[killer] == 200)
					{
						client_print(killer, print_chat, "[Achievements] You unlocked ^"Perfectionist^"")
					}
				}
			}
			
			
			if(g_infectinrowcount1[killer] != 5)
			{
				g_zmkillrowcount1[killer]++
				
				if(g_zmkillrowcount1[killer] == 5)
				{
					client_print(killer, print_chat, "[Achievements] You unlocked ^"Flyswatter^"")
				}
			}
			else if(g_zmkillrowcount2[killer] != 10)
			{
				g_zmkillrowcount2[killer]++
				
				if(g_zmkillrowcount2[killer] == 10)
				{
					client_print(killer, print_chat, "[Achievements] You unlocked ^"Sureshot^"")
				}
			}
			
			// Achievements
			if(g_ZombieKillCount1[killer] != 100)
			{
				g_ZombieKillCount1[killer]++
				
				if(g_ZombieKillCount1[killer] == 100)
				{
					client_print(killer, print_chat, "[Achievements] You unlocked ^"Zombies are Better Off Dead^"")
				}
			}
			else
			{
				// 1. Level is OK
				if(g_ZombieKillCount2[killer] != 600)
				{
					g_ZombieKillCount2[killer]++
					
					if(g_ZombieKillCount2[killer] == 600)
					{
						client_print(killer, print_chat, "[Achievements] You unlocked ^"Zombie Assassinator^"")
					}
				}
				else
				{
					// 2. Level is ok.
					if(g_ZombieKillCount3[killer] != 1000)
					{
						g_ZombieKillCount3[killer]++
						
						if(g_ZombieKillCount3[killer] == 1000)
						{
							client_print(killer, print_chat, "[Achievements] You unlocked ^"Expert Zombie Killer^"")
						}
					}
				}
			}
		}
		
		if(!zp_get_user_zombie(killer) && hs)
		{
			if(zp_get_user_zombie(victim) || zp_get_user_nemesis(victim))
			{
				g_ZombieHSKillCount[killer]++
				
				if(g_ZombieHSKillCount[killer] == 600)
				{
					client_print(killer, print_chat, "[Achievements] You unlocked ^"Boom! Headshot^"")
				}
			}
		}
		
		// Human kills Zombie by Knife
		if(is_hkz_knife_kill(killer, victim))
		{
			g_TotalPoints[killer] += 10
			g_HumanKillsZombieKnifePoints[killer] += 10
			
			client_print(killer, print_chat, "[Status] You just got 10 Points for killing a Zombie by Knife.")
		}
		
		// Human kills Nemesis
		if(is_hkn_kill(killer, victim))
		{
			g_TotalPoints[killer] += 10
			g_HumanKillsNemesisPoints[killer] += 10
			
			client_print(killer, print_chat, "[Status] You just got 10 Points for killing a Nemesis.")
			
			// Achievements
			new weapon = get_user_weapon(killer)
			if(weapon == CSW_KNIFE)
			{
				if(g_nemeKillCountKnife[killer] != 10)
				{
					g_nemeKillCountKnife[killer]++
					
					if(g_nemeKillCountKnife[killer] == 10)
					{
						client_print(killer, print_chat, "[Achievements] You unlocked ^"Nerves of Steel^"")
					}
				}
			}
		}
		
		//achievement
		if(zp_get_user_nemesis(victim) && !zp_get_user_zombie(killer))
		{
			if(zp_is_plague_round())
			{
				if(g_killnemesisplague[killer] != 300)
				{
					g_killnemesisplague[killer]++
					
					if(g_killnemesisplague[killer] == 300)
					{
						client_print(killer, print_chat, "[Achievements] You unlocked ^"Think Fast!^"")
					}
				}
				
				if(g_kill600nemesis[killer] != 600)
				{
					g_kill600nemesis[killer]++
					
					if(g_kill600nemesis[killer] == 600)
					{
						client_print(killer, print_chat, "[Achievements] You unlocked ^"Rejected^"")
					}
				}
			}
			else
			{
				if(g_kill600nemesis[killer] != 600)
				{
					g_kill600nemesis[killer]++
					
					if(g_kill600nemesis[killer] == 600)
					{
						client_print(killer, print_chat, "[Achievements] You unlocked ^"Rejected^"")
					}
				}
			}
		} 
		
		// Survivor kills Zombie
		if(is_skz_kill(killer, victim))
		{
			g_TotalPoints[killer] += 6
			g_SurvivorKillsZombiePoints[killer] += 6
			
			client_print(killer, print_chat, "[Status] You just got 6 Points for killing a Zombie while you are a Survivor.")
			
			// Achievements
			
			if(zp_get_user_last_zombie(victim))
			{
				if(g_winsurvivor[killer] != 10)
				{
					g_winsurvivor[killer]++
					
					if(g_winsurvivor[killer] == 10)
					{
						client_print(killer, print_chat, "[Achievements] You unlocked ^"Survivor^"")
					}
				}
				
			}
		}
		
		// ZOMBIE STATISTICS	
		
		// Nemesis kills Human
		if(is_nkh_kill(killer, victim))
		{
			g_TotalPoints[killer] += 3
			g_NemesisKillsHuman[killer] += 3
			
			client_print(killer, print_chat, "[Status] You just got 3 Points for killing a Human while beeing a Nemesis.")
			
			// Achievements
			
			if(zp_get_user_last_human(victim))
			{
				if(g_winnemesis[killer] != 10)
				{
					g_winnemesis[killer]++
					
					if(g_winnemesis[killer] == 10)
					{
						client_print(killer, print_chat, "[Achievements] You unlocked ^"Nemesis^"")
					}
				}
				
			}
		}
		
		// Zombie kill survivor
		if(is_zks_kill(killer, victim))
		{
			g_TotalPoints[killer] += 10
			g_ZombieKillsSurvivor[killer] += 10
			
			client_print(killer, print_chat, "[Status] You just got 10 Points for killing the Sruvivor.")
		}
		
		//achievement
		if(zp_get_user_survivor(victim) && zp_get_user_zombie(killer))
		{
			if(zp_is_plague_round())
			{
				if(g_killsurvivorplague[killer] != 300)
				{
					g_killsurvivorplague[killer]++
					
					if(g_killsurvivorplague[killer] == 300)
					{
						client_print(killer, print_chat, "[Achievements] You unlocked ^"Ninja^"")
					}
				}
				
				if(g_kill600survivor[killer] != 600)
				{
					g_kill600survivor[killer]++
					
					if(g_kill600survivor[killer] == 600)
					{
						client_print(killer, print_chat, "[Achievements] You unlocked ^"Heartbreaker^"")
					}
				}
			}
			else
			{
				if(g_kill600survivor[killer] != 600)
				{
					g_kill600survivor[killer]++
					
					if(g_kill600survivor[killer] == 600)
					{
						client_print(killer, print_chat, "[Achievements] You unlocked ^"Heartbreaker^"")
					}
				}
			}
		}
		
		// Zombie kills Human
		if(is_zkhps_kill(killer, victim))
		{
			g_TotalPoints[killer] += 4
			g_ZombieKillsHumanPS[killer] += 4
			
			client_print(killer, print_chat, "[Status] You just got 4 Points for killing a Human")
			
			// Achievements
			
			// Zombie Kill/Infect Achivement
			if(g_KillInfectCount1[killer] != 200)
			{
				g_KillInfectCount1[killer]++
				
				if(g_KillInfectCount1[killer] == 200)
				{
					client_print(killer, print_chat, "[Achievements] You unlocked ^"Mmmmm Brains...^"")
				}
			}
			else
			{
				// 1. Level is OK
				if(g_KillInfectCount2[killer] != 1200)
				{
					g_KillInfectCount2[killer]++
					
					if(g_KillInfectCount2[killer] == 1200)
					{
						client_print(killer, print_chat, "[Achievements] You unlocked ^"Phoenix Rising^"")
					}
				}
				else
				{
					// 2. Level is ok.
					if(g_KillInfectCount3[killer] != 2000)
					{
						g_KillInfectCount3[killer]++
						
						if(g_KillInfectCount3[killer] == 2000)
						{
							client_print(killer, print_chat, "[Achievements] You unlocked ^"Infected^"")
						}
					}
				}
			}
			
			// Got Killed / Infected Achievements   
			g_gotKillInfectCount[victim]++
			if(g_gotKillInfectCount[victim] == 1000)
			{
				client_print(killer, print_chat, "[Achievements] You unlocked ^"Enemies With Benefits^"")
			}
		}
	}
	
	return PLUGIN_CONTINUE
}

public zp_user_infected_pre(infected, infector, nemesis)
{
	if(!g_LoggedIn[infector]) return PLUGIN_HANDLED
	
	if(is_valid_player(infected) && is_valid_player(infector))
	{
		// zombie infects human
		if(is_zih_infect(infected, infector, nemesis))
		{
			g_TotalPoints[infector] += 3
			g_ZombieInfectsHumanPoints[infector] += 3
			
			client_print(infector, print_chat, "[Status] You just got 3 Points for infecting a Human.")
			
			// Achievements
			
			if(g_KillInfectCount1[infector] != 200)
			{
				g_KillInfectCount1[infector]++
				
				if(g_KillInfectCount1[infector] == 200)
				{
					client_print(infector, print_chat, "[Achievements] You unlocked ^"Mmmmm Brains...^"")
				}
			}
			else
			{
				// 1. Level is OK
				if(g_KillInfectCount2[infector] != 1200)
				{
					g_KillInfectCount2[infector]++
					
					if(g_KillInfectCount2[infector] == 1200)
					{
						client_print(infector, print_chat, "[Achievements] You unlocked ^"Phoenix Rising^"")
					}
				}
				else
				{
					// 2. Level is ok.
					if(g_KillInfectCount3[infector] != 2000)
					{
						g_KillInfectCount3[infector]++
						
						if(g_KillInfectCount3[infector] == 2000)
						{
							client_print(infector, print_chat, "[Achievements] You unlocked ^"Infected^"")
						}
					}
				}
			}
			
			if(g_infectinrowcount1[infector] != 5)
			{
				g_infectinrowcount1[infector]++
				
				if(g_infectinrowcount1[infector] == 5)
				{
					client_print(infector, print_chat, "[Achievements] You unlocked ^"Bulletproof^"")
				}
			}
			else if(g_infectinrowcount2[infector] != 10)
			{
				g_infectinrowcount2[infector]++
				
				if(g_infectinrowcount2[infector] == 10)
				{
					client_print(infector, print_chat, "[Achievements] You unlocked ^"Angel of Death^"")
				}
			}
			
			// Got Killed / Infected Achievements   
			g_gotKillInfectCount[infected]++
			if(g_gotKillInfectCount[infected] == 1000)
			{
				client_print(infected, print_chat, "[Achievements] You unlocked ^"Enemies With Benefits^"")
			}
		}
	}
	
	return PLUGIN_CONTINUE
}

/* From here: STATUS POINTS SYSTEM FUNCTIONS *+*+*+*+* */

// killer: Zombie
// victim: Human
// rounds: Plague/Swarm
public is_zkhps_kill(killer, victim)
{
	if(zp_get_user_zombie(killer) && !zp_get_user_zombie(victim) && !zp_get_user_survivor(victim) && !zp_get_user_nemesis(killer))
		return 1
	else
		return 0
	
	return PLUGIN_CONTINUE
}

// killer: Zombie No Neme
// victim: survivor
// rounds: survivorround
public is_zks_kill(killer, victim)
{
	if(zp_get_user_zombie(killer) && zp_get_user_survivor(victim) && zp_is_survivor_round() && !zp_get_user_nemesis(killer))
		return 1
	else
		return 0
	
	return PLUGIN_CONTINUE
}

// killer: Nemesis
public is_nkh_kill(killer, victim)
{
	if(zp_get_user_nemesis(killer))
		return 1
	else
		return 0
	
	return PLUGIN_CONTINUE
}

// Infector: Is Zombie, not turned to nemesis
public is_zih_infect(infected, infector, turnedtonemesis)
{
	if(zp_get_user_zombie(infector) && !turnedtonemesis)
		return 1
	else
		return 0
	
	return PLUGIN_CONTINUE
}

// killer: Human, No survivor
// victim: Is Zombie, not Nemesis
// rounds: No nemeround, no plgue/swarm, no survivorround
public is_hkz_kill(killer, victim)
{
	if(!zp_get_user_zombie(killer) && !zp_get_user_survivor(killer) && !zp_get_user_nemesis(victim) && zp_get_user_zombie(victim) && !zp_is_nemesis_round() && !zp_is_survivor_round())
		return 1
	else
		return 0
	
	return PLUGIN_CONTINUE
}

// killer: Human KILL BY KNIFE
// victim: Is Zombie
public is_hkz_knife_kill(killer, victim)
{
	if(!zp_get_user_zombie(killer) && zp_get_user_zombie(victim))
	{
		new weapon = get_user_weapon(killer)
		if(weapon == CSW_KNIFE)
		{
			return 1
		}
	}
	else
		return 0
	
	return PLUGIN_CONTINUE
}

// killer: no zombie
// victim: is Nemesis
// rounds: is neme round
public is_hkn_kill(killer, victim)
{
	if(!zp_get_user_zombie(killer) && zp_get_user_nemesis(victim) && zp_is_nemesis_round())
		return 1
	else
		return 0
	
	return PLUGIN_CONTINUE
}

// killer: is Survivor
// victim: is zombie
// rounds: is Survivor round
public is_skz_kill(killer, victim)
{
	if(zp_get_user_survivor(killer) && zp_get_user_zombie(victim) && zp_is_survivor_round())
		return 1
	else
		return 0
	
	return PLUGIN_CONTINUE
}

public menuStats(id)
{
	if(!g_LoggedIn[id])
	{
		client_print(id, print_chat, "[Stats] You arent logged in.")
		return PLUGIN_HANDLED
	}
	else
	{
		new menuStatistics = menu_create("\yStatistics", "menuStatsHandler")
		
		menu_additem(menuStatistics, "\yTop15^n", "1")
		
		new szTotalPoints[60]
		formatex(szTotalPoints, 59, "\wTotal Points: \r%i", g_TotalPoints[id])
		menu_addtext(menuStatistics, szTotalPoints, 0)
		
		new szMin[60]
		formatex(szMin, 59, "\wPlayed Minutes: \r%i", g_Minutes[id])
		menu_addtext(menuStatistics, szMin, 0)
		
		new szRounds[60]
		formatex(szRounds, 59, "\wPlayed Rounds: \r%i^n", g_Rounds[id])
		menu_addtext(menuStatistics, szRounds, 0)
		
		// HUMAN
		
		new szHKZ[60]
		formatex(szHKZ, 59, "\wHuman Kills Zombie: \y%i Kills\r (%i Points)", g_HumanKillsZombiePoints[id] / 6, g_HumanKillsZombiePoints[id])
		menu_addtext(menuStatistics, szHKZ, 0)
		
		new szHKZknife[60]
		formatex(szHKZknife, 59, "\wHuman Kills Zombie by Knife: \y%i Kills\r (%i Points)", g_HumanKillsZombieKnifePoints[id] / 10, g_HumanKillsZombieKnifePoints[id])
		menu_addtext(menuStatistics, szHKZknife, 0)
		
		new szHKN[60]
		formatex(szHKN, 59, "\wHuman Kills Nemesis: \y %i Kills\r (%i Points)", g_HumanKillsNemesisPoints[id] / 10, g_HumanKillsNemesisPoints[id])
		menu_addtext(menuStatistics, szHKN, 0)
		
		new szSKZ[60]
		formatex(szSKZ, 59, "\wSurvivor Kills Zombie: \y %i Kills\r (%i Points)^n^n", g_SurvivorKillsZombiePoints[id] / 6, g_SurvivorKillsZombiePoints[id])
		menu_addtext(menuStatistics, szSKZ, 0)
		
		// Zombie
		
		new szZIH[60]
		formatex(szZIH, 59, "\wZombie Infects Human: \y %i Infects\r (%i Points)", g_ZombieInfectsHumanPoints[id] / 3, g_ZombieInfectsHumanPoints[id])
		menu_addtext(menuStatistics, szZIH, 0)
		
		new szZKH[60]
		formatex(szZKH, 59, "\wZombie Kills Human: \y %i Kills\r (%i Points)", g_ZombieKillsHumanPS[id] / 4, g_ZombieKillsHumanPS[id])
		menu_addtext(menuStatistics, szZKH, 0)
		
		new szZKS[60]
		formatex(szZKS, 59, "\wZombie Kills Survivor: \y %i Kills\r (%i Points)", g_ZombieKillsSurvivor[id] / 10, g_ZombieKillsSurvivor[id])
		menu_addtext(menuStatistics, szZKS, 0)
		
		new szNKH[60]
		formatex(szNKH, 59, "\wNemesis Kills Human: \y %i Kills\r (%i Points)", g_NemesisKillsHuman[id] / 3, g_NemesisKillsHuman[id])
		menu_addtext(menuStatistics, szNKH, 0)
		
		menu_display(id, menuStatistics, 0)
	}
	
	return PLUGIN_CONTINUE
}

public menuStatsHandler(id, menu, item)
{
	new data[6], iName[64], access, callback
	menu_item_getinfo(menu, item, access, data, 5, iName, 63, callback)
	
	new key = str_to_num(data)
	
	switch(key)
	{
		// Top10
		case 1:
		{
			cmdTop10(id)
		}
	}
	
	menu_destroy(menu)
}


public cmdTop10(id)
{
	g_Top10TempID = id
	SQL_ThreadQuery(g_SqlTuple, "top10Thread","SELECT * FROM zp_rabs ORDER BY totalpoints DESC LIMIT 10")
}

public top10Thread(FailState,Handle:Query,Error[],Errcode,Data[],DataSize)
{
	if(FailState == TQUERY_CONNECT_FAILED)
		return set_fail_state("Could not connect to SQL database.")
	else if(FailState == TQUERY_QUERY_FAILED)
		return set_fail_state("Query failed.")
	
	if(Errcode)
		return log_amx("Error on query: %s",Error)
	
	new id = g_Top10TempID
	
	const SIZE = 9000;
	new msg[SIZE + 1]
	new len;
	
	len += formatex(msg[len], SIZE, "<html><body><h1>Top10</h1>")
	
	len += formatex(msg[len], SIZE-len, "<table border=^"1^">")
	
	len += formatex(msg[len], SIZE-len, "<tr><td>Rank</td>")
	
	len += formatex(msg[len], SIZE-len, "<td style=^"width: 40px;^">Name</td>")
	
	len += formatex(msg[len], SIZE-len, "<td>Total Points</td>")
	
	len += formatex(msg[len], SIZE-len, "<td>Killed Zombies</td>")
	
	len += formatex(msg[len], SIZE-len, "<td>Killed Humans</td>")
	
	len += formatex(msg[len], SIZE-len, "<td>Killed Nemesises</td>")
	
	len += formatex(msg[len], SIZE-len, "<td>Killed Survivors</td>")
	
	len += formatex(msg[len], SIZE-len, "<td>Infected Humans</td></tr>")
	
	new name[45], totalpoints, hkzpoints, hknpoints, zih, zks, zkh
	
	new count = 1
	while(SQL_MoreResults(Query))
	{
		// columns start at 0
		totalpoints = SQL_ReadResult(Query, 2)
		hkzpoints = SQL_ReadResult(Query, 3)
		hknpoints = SQL_ReadResult(Query, 4)
		zih = SQL_ReadResult(Query, 7)
		zks = SQL_ReadResult(Query, 9)
		zkh = SQL_ReadResult(Query, 10)
		SQL_ReadResult(Query, 0, name, 44)
		
		
		len += formatex(msg[len], SIZE-len, "<tr><td>%i.</td>", count)
		
		len += formatex(msg[len], SIZE-len, "<td>%s</td>", name)
		
		len += formatex(msg[len], SIZE-len, "<td>%i</td>", totalpoints)
		
		len += formatex(msg[len], SIZE-len, "<td>%i</td>", hkzpoints / 6)
		
		len += formatex(msg[len], SIZE-len, "<td>%i</td>", zkh / 4, zkh)
		
		len += formatex(msg[len], SIZE-len, "<td>%i</td>", hknpoints / 10)
		
		len += formatex(msg[len], SIZE-len, "<td>%i</td>", zks / 10)
		
		len += formatex(msg[len], SIZE-len, "<td>%i</td></tr>", zih / 3)
		
		count++
		
		SQL_NextRow(Query)
	}
	
	len = formatex(msg[len], SIZE-len, "</table></body></html>")
	
	show_motd(id, msg, "Top10")
	
	return PLUGIN_CONTINUE
}

public cmdRank(id)
{
	if(!g_LoggedIn[id]) 
		return PLUGIN_HANDLED
	
	g_RankTempID = id
	
	SQL_ThreadQuery(g_SqlTuple,"rankThread","SELECT username, totalpoints FROM zp_rabs ORDER BY totalpoints DESC")
	
	return PLUGIN_CONTINUE
}

public rankThread(FailState,Handle:Query,Error[],Errcode,Data[],DataSize)
{
	if(FailState == TQUERY_CONNECT_FAILED)
		return set_fail_state("Could not connect to SQL database.")
	else if(FailState == TQUERY_QUERY_FAILED)
		return set_fail_state("Query failed.")
	
	if(Errcode)
		return log_amx("Error on query: %s",Error)
	
	new iRowsFound = SQL_NumRows(Query)
	
	new szName[50]
	new iRank
	new iRowCount
	
	while(SQL_MoreResults(Query))
	{
		iRowCount++
		
		SQL_ReadResult(Query, 0, szName, 49)
		
		if(equal(g_szTempName[g_RankTempID], szName))
		{
			iRank = iRowCount
			break
		}
		
		SQL_NextRow(Query)
	}
	
	client_print(g_RankTempID, print_chat, "Your rank is %i of %i with %i Points in Total",iRank, iRowsFound, g_TotalPoints[g_RankTempID])
	
	
	return PLUGIN_CONTINUE
}

/* END: STATUS POINTS SYSTEM FUNCTIONS */

/* From Here: REGISTER SYSTEM FUNCTIONS +*+*+*+ */
public menuRegister(id)
{
	// Show him the menu just if he isnt logged in so far
	if(g_LoggedIn[id] && is_valid_player(id))
	{
		client_print(id, print_chat, "[Login] You are logged in. Rejoin if you want to login again!")
	}
	if(!g_LoggedIn[id] && is_valid_player(id))
	{
		new menuLoginCreate = menu_create("\yRegister System", "menuLoginCreateHandler")
		
		menu_additem(menuLoginCreate, "\wNew Account", "1")
		menu_additem(menuLoginCreate, "\rLogin^n", "2")
		
		menu_display(id, menuLoginCreate, 0)
		
		// Prevent them from Joining a Team
		return PLUGIN_HANDLED
	}
	
	return PLUGIN_CONTINUE
}

public menuLoginCreateHandler(id, menuLoginCreate, item)
{		
	new data[6], iName[64], access, callback
	menu_item_getinfo(menuLoginCreate, item, access, data, 5, iName, 63, callback)
	
	new key = str_to_num(data)
	
	switch(key)
	{
		// New Account
		case 1:
		{
			g_RegisterSelection[id] = 1
			client_cmd(id, "messagemode Username")
		}
		case 2:
		{
			g_RegisterSelection[id] = 2
			client_cmd(id, "messagemode Username")
		}
	}
}

public cmdUsername(id)
{
	// if user is already logged in stop him
	if(g_LoggedIn[id])
	{
		return PLUGIN_HANDLED
	}
	
	read_args(g_szTempName[id], 99)
	remove_quotes(g_szTempName[id])
	
	if(contain(g_szTempName[id], " ") != -1 || strlen(g_szTempName[id]) < 3)
	{
		client_print(id, print_chat, "[Login] Invalid Username. Try another one now.")
		client_cmd(id, "messagemode Username")
		
		return PLUGIN_HANDLED
	}
	
	
	if(g_RegisterSelection[id] == 1 || g_RegisterSelection[id] == 2)
	{
		new ErrorCode
		new Error[512]
		new Handle:SqlConnection = SQL_Connect(g_SqlTuple, ErrorCode, Error, 511)
		
		if(SqlConnection == Empty_Handle)
		{	
			set_fail_state(Error)
		}
		
		new Handle:Query = SQL_PrepareQuery(SqlConnection, "SELECT * FROM zp_rabs WHERE username='%s'", g_szTempName[id])
		
		if(!SQL_Execute(Query))
		{
			SQL_QueryError(Query, Error, 511)
			set_fail_state(Error)
		}
		
		new iRowsFound = SQL_NumRows(Query)
		
		switch(g_RegisterSelection[id])
		{
			case 1:
			{
				// No Resluts
				if(iRowsFound < 1)
				{
					client_cmd(id, "messagemode szPassword")
				}
				// Username Found
				else
				{
					client_print(id, print_chat, "[Login] This username is already given to someone else. Try another one now.")
					client_cmd(id, "messagemode Username")
				}
			}
			case 2:
			{
				// No Resluts
				if(iRowsFound < 1)
				{
					client_print(id, print_chat, "[Login] This username is not registered on this server. Please try it again now!")
					client_cmd(id, "messagemode Username")
				}
				// Username Found
				else
				{
					client_cmd(id, "messagemode szPassword")
				}
			}
		}
		
		
		SQL_FreeHandle(Query)
		SQL_FreeHandle(SqlConnection)   	
	}
	
	return PLUGIN_CONTINUE
}

public cmdPw(id)
{
	// if user is already logged in stop him
	if(g_LoggedIn[id] == true)
	{
		return PLUGIN_HANDLED
	}
	
	read_args(g_szTempPassWord[id], 99)
	remove_quotes(g_szTempPassWord[id])
	
	if(contain(g_szTempPassWord[id], " ") != -1 || strlen(g_szTempPassWord[id]) < 3 || strlen(g_szTempName[id]) < 3)
	{
		client_print(id, print_chat, "[Login] Invalid Password. Try another one now.")
		client_cmd(id, "messagemode szPassword")
		
		return PLUGIN_HANDLED
	}
	
	switch(g_RegisterSelection[id])
	{
		// Register new User
		case 1:
		{
			new ErrorCode
			new Error[512]
			new Handle:SqlConnection = SQL_Connect(g_SqlTuple, ErrorCode, Error, 511)
			
			if(SqlConnection == Empty_Handle)
			{	
				set_fail_state(Error)
			}
			
			new Handle:Query = SQL_PrepareQuery(SqlConnection, "INSERT INTO zp_rabs VALUES('%s','%s', '0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0')", g_szTempName[id], g_szTempPassWord[id])
			
			if(!SQL_Execute(Query))
			{
				SQL_QueryError(Query, Error, 511)
				set_fail_state(Error)
			}
			
			// Set him to zombies
			client_cmd(id, "jointeam 2")
			
			// Set user as new in User
			g_LoggedIn[id] = true
			
			// Print him a Message
			client_print(id, print_chat, "[Login] You successfully created a new Account")
			client_print(id, print_chat, "[Login] Username = '%s'", g_szTempName[id])
			client_print(id, print_chat, "[Login] Password = '%s'", g_szTempPassWord[id])
			
			SQL_FreeHandle(Query)
			SQL_FreeHandle(SqlConnection)
		}
		// Login User
		case 2:
		{
			new ErrorCode
			new Error[512]
			new Handle:SqlConnection = SQL_Connect(g_SqlTuple, ErrorCode, Error, 511)
			
			if(SqlConnection == Empty_Handle)
			{	
				set_fail_state(Error)
			}
			
			new Handle:Query = SQL_PrepareQuery(SqlConnection, "SELECT * FROM zp_rabs WHERE username='%s'", g_szTempName[id])
			
			if(!SQL_Execute(Query))
			{
				SQL_QueryError(Query, Error, 511)
				set_fail_state(Error)
			}
			
			new szSqlPassword[100]
			SQL_ReadResult(Query, 1, szSqlPassword, 99)
			
			// if password is right
			if(equal(g_szTempPassWord[id], szSqlPassword))
			{
				// Kick Player who has logged in with same data
				new players[32], pnum, tempid
				get_players(players, pnum)
				
				for(new i; i<pnum; i++)
				{
					tempid = players[i]
					if(equal(g_szTempName[id], g_szTempName[tempid]) && id != tempid)
					{
						client_cmd(tempid, "disconnect")
					}
				}
				
				// Set him to zombies
				client_cmd(id, "jointeam 2")
				g_LoggedIn[id] = true
				
				// Get Data from Database
				g_TotalPoints[id] = SQL_ReadResult(Query, 2)
				g_HumanKillsZombiePoints[id] = SQL_ReadResult(Query, 3)
				g_HumanKillsNemesisPoints[id] = SQL_ReadResult(Query, 4)
				g_SurvivorKillsZombiePoints[id] = SQL_ReadResult(Query, 5)
				g_HumanKillsZombieKnifePoints[id] = SQL_ReadResult(Query, 6)
				g_ZombieInfectsHumanPoints[id] = SQL_ReadResult(Query, 7)
				g_NemesisKillsHuman[id] = SQL_ReadResult(Query, 8)
				g_ZombieKillsSurvivor[id] = SQL_ReadResult(Query, 9)
				g_ZombieKillsHumanPS[id] = SQL_ReadResult(Query, 10)
				g_AP[id] = SQL_ReadResult(Query, 11)
				g_Minutes[id] = SQL_ReadResult(Query, 12)
				g_ZombieKillCount1[id] = SQL_ReadResult(Query, 13)
				g_ZombieKillCount2[id] = SQL_ReadResult(Query, 14)
				g_ZombieKillCount3[id] = SQL_ReadResult(Query, 15)
				g_ZombieHSKillCount[id] = SQL_ReadResult(Query, 16)
				g_Rounds[id] = SQL_ReadResult(Query, 17)
				g_KillInfectCount1[id] = SQL_ReadResult(Query, 18)
				g_KillInfectCount2[id] = SQL_ReadResult(Query, 19)
				g_KillInfectCount3[id] = SQL_ReadResult(Query, 20)
				g_gotKillInfectCount[id] = SQL_ReadResult(Query, 21)
				g_nemeKillCountKnife[id] = SQL_ReadResult(Query, 22)
				g_killzombieknife[id] = SQL_ReadResult(Query, 23)
				g_winsurvivor[id] = SQL_ReadResult(Query, 24)
				g_winnemesis[id] = SQL_ReadResult(Query, 25)
				g_killsurvivorplague[id] = SQL_ReadResult(Query, 26)
				g_killnemesisplague[id] = SQL_ReadResult(Query, 27)
				g_kill600survivor[id] = SQL_ReadResult(Query, 28)
				g_kill600nemesis[id] = SQL_ReadResult(Query, 29)
				g_InfectionBombCount[id] = SQL_ReadResult(Query, 30)
				g_SprayCount[id] = SQL_ReadResult(Query, 31)
				g_awpkills[id] = SQL_ReadResult(Query, 32)
				g_infectinrowcount1[id] = SQL_ReadResult(Query, 33)
				g_infectinrowcount2[id] = SQL_ReadResult(Query, 34)
				g_zmkillrowcount1[id] = SQL_ReadResult(Query, 35)
				g_zmkillrowcount2[id] = SQL_ReadResult(Query, 36)
				g_lasthumankillall[id] = SQL_ReadResult(Query, 37)
				
				client_print(id, print_chat, "[Login] Welcome %s.", g_szTempName[id])
			}
			else
			{
				client_print(id, print_chat, "[Login] Wrong Password! Try it again please.")
				client_cmd(id, "messagemode szPassword")
			}
			
			SQL_FreeHandle(Query)
			SQL_FreeHandle(SqlConnection)
		}
	}
	
	return PLUGIN_CONTINUE
}

/* END: REGISTER SYSTEM FUNCTIONS +*+*+*+ */

public client_disconnect(id)
{	
	updateTable(id)
	
	g_LoggedIn[id] = false
	g_szTempName[id][0] = EOS
	g_szTempPassWord[id][0] = EOS
	
	g_TotalPoints[id] = 0
	
	g_HumanKillsNemesisPoints[id] = 0
	g_HumanKillsZombiePoints[id] = 0
	g_SurvivorKillsZombiePoints[id] = 0
	g_HumanKillsZombieKnifePoints[id] = 0
	
	g_ZombieInfectsHumanPoints[id] = 0
	g_NemesisKillsHuman[id] = 0
	g_ZombieKillsSurvivor[id] = 0
	g_ZombieKillsHumanPS[id] = 0
	
	g_AP[id] = 0
	
	g_Minutes[id] = 0
	g_ZombieKillCount1[id] = 0
	g_ZombieKillCount2[id] = 0
	g_ZombieKillCount3[id] = 0
	g_ZombieHSKillCount[id] = 0
	g_Rounds[id] = 0
	g_KillInfectCount1[id] = 0
	g_KillInfectCount2[id] = 0
	g_KillInfectCount3[id] = 0
	g_gotKillInfectCount[id] = 0
	g_killzombieknife[id] = 0
	g_nemeKillCountKnife[id] = 0
	g_killsurvivorplague[id] = 0
	g_killnemesisplague[id] = 0
	g_kill600survivor[id] = 0
	g_kill600nemesis[id] = 0
	g_InfectionBombCount[id] = 0
	g_SprayCount[id] = 0
	g_awpkills[id] = 0
	g_infectinrowcount1[id] = 0
	g_infectinrowcount2[id] = 0
	g_zmkillrowcount1[id] = 0
	g_zmkillrowcount2[id] = 0
	g_lasthumankillall[id] = 0
}

public updateTable(id)
{
	// Save Data
	if(g_LoggedIn[id])
	{
		new szQuery[2048]
		new len = 0
		g_AP[id] += zp_get_user_ammo_packs(id)
		zp_set_user_ammo_packs(id, 0)
		
		len += format(szQuery[len], 2048, "UPDATE zp_rabs SET ")
		len += format(szQuery[len], 2048-len,"totalpoints = '%i', ", g_TotalPoints[id])
		len += format(szQuery[len], 2048-len,"hkzpoints = '%i', ", g_HumanKillsZombiePoints[id])
		len += format(szQuery[len], 2048-len,"hknpoints = '%i', ", g_HumanKillsNemesisPoints[id])
		len += format(szQuery[len], 2048-len,"skzpoints = '%i', ", g_SurvivorKillsZombiePoints[id])
		len += format(szQuery[len], 2048-len,"hkzknifepoints = '%i', ", g_HumanKillsZombieKnifePoints[id])
		len += format(szQuery[len], 2048-len,"zihpoints = '%i', ", g_ZombieInfectsHumanPoints[id])
		len += format(szQuery[len], 2048-len,"nkhpoints = '%i', ", g_NemesisKillsHuman[id])
		len += format(szQuery[len], 2048-len,"zkspoints = '%i', ", g_ZombieKillsSurvivor[id])
		len += format(szQuery[len], 2048-len,"zkhpspoints = '%i', ", g_ZombieKillsHumanPS[id])
		len += format(szQuery[len], 2048-len,"ammopacks = '%i', ", g_AP[id])
		len += format(szQuery[len], 2048-len,"minutesplayed = '%i', ", g_Minutes[id])
		len += format(szQuery[len], 2048-len,"zombiekills1 = '%i', ", g_ZombieKillCount1[id])
		len += format(szQuery[len], 2048-len,"zombiekills2 = '%i', ", g_ZombieKillCount2[id])
		len += format(szQuery[len], 2048-len,"zombiekills3 = '%i', ", g_ZombieKillCount3[id])
		len += format(szQuery[len], 2048-len,"zombiehskills = '%i', ", g_ZombieHSKillCount[id])
		len += format(szQuery[len], 2048-len,"rounds = '%i', ", g_Rounds[id])
		len += format(szQuery[len], 2048-len,"humankillinfect1 = '%i', ", g_KillInfectCount1[id])
		len += format(szQuery[len], 2048-len,"humankillinfect2 = '%i', ", g_KillInfectCount2[id])
		len += format(szQuery[len], 2048-len,"humankillinfect3 = '%i', ", g_KillInfectCount3[id])
		len += format(szQuery[len], 2048-len,"gotkilledinfected = '%i', ", g_gotKillInfectCount[id])
		len += format(szQuery[len], 2048-len,"nemekillknife = '%i', ", g_nemeKillCountKnife[id])
		len += format(szQuery[len], 2048-len,"zombiekillknife = '%i', ", g_nemeKillCountKnife[id])
		len += format(szQuery[len], 2048-len,"winsurvivor = '%i', ", g_winsurvivor[id])
		len += format(szQuery[len], 2048-len,"winnemesis = '%i', ", g_winnemesis[id])
		len += format(szQuery[len], 2048-len,"ninja = '%i', ", g_killsurvivorplague[id])
		len += format(szQuery[len], 2048-len,"thinkfast = '%i', ", g_killnemesisplague[id])
		len += format(szQuery[len], 2048-len,"kill600survivor = '%i', ", g_kill600survivor[id])
		len += format(szQuery[len], 2048-len,"kill600nemesis = '%i', ", g_kill600nemesis[id])
		len += format(szQuery[len], 2048-len,"infectionbomb = '%i', ", g_InfectionBombCount[id])
		len += format(szQuery[len], 2048-len,"sprays = '%i', ", g_SprayCount[id])
		len += format(szQuery[len], 2048-len,"awpkills = '%i', ", g_awpkills[id])
		len += format(szQuery[len], 2048-len,"infectround1 = '%i', ", g_infectinrowcount1[id])
		len += format(szQuery[len], 2048-len,"infectround2 = '%i', ", g_infectinrowcount2[id])
		len += format(szQuery[len], 2048-len,"zmkillrow1 = '%i', ", g_zmkillrowcount1[id])
		len += format(szQuery[len], 2048-len,"zmkillrow2 = '%i', ", g_zmkillrowcount2[id])
		len += format(szQuery[len], 2048-len,"lasthumankillall = '%i' ", g_lasthumankillall[id])
		len += format(szQuery[len], 2048-len,"WHERE username = '%s'", g_szTempName[id])
		
		SQL_ThreadQuery(g_SqlTuple,"updateTableThread", szQuery)
	}
}

public updateTableThread(FailState,Handle:Query,Error[],Errcode,Data[],DataSize)
{
	// lots of error checking
	if(FailState == TQUERY_CONNECT_FAILED)
		return set_fail_state("Could not connect to SQL database.")
	else if(FailState == TQUERY_QUERY_FAILED)
		return set_fail_state("Query failed.")
	
	if(Errcode)
		return log_amx("Error on query: %s",Error)
	
	return PLUGIN_CONTINUE
}

public updateTableStats(id)
{
	// Save Data
	if(g_LoggedIn[id])
	{
		new szQuery[2048]
		new len = 0
		
		len += format(szQuery[len], 2048, "UPDATE zp_rabs SET ")
		len += format(szQuery[len], 2048-len,"totalpoints = '%i', ", g_TotalPoints[id])
		len += format(szQuery[len], 2048-len,"hkzpoints = '%i', ", g_HumanKillsZombiePoints[id])
		len += format(szQuery[len], 2048-len,"hknpoints = '%i', ", g_HumanKillsNemesisPoints[id])
		len += format(szQuery[len], 2048-len,"skzpoints = '%i', ", g_SurvivorKillsZombiePoints[id])
		len += format(szQuery[len], 2048-len,"hkzknifepoints = '%i', ", g_HumanKillsZombieKnifePoints[id])
		len += format(szQuery[len], 2048-len,"zihpoints = '%i', ", g_ZombieInfectsHumanPoints[id])
		len += format(szQuery[len], 2048-len,"nkhpoints = '%i', ", g_NemesisKillsHuman[id])
		len += format(szQuery[len], 2048-len,"zkspoints = '%i', ", g_ZombieKillsSurvivor[id])
		len += format(szQuery[len], 2048-len,"zkhpspoints = '%i' ", g_ZombieKillsHumanPS[id])
		len += format(szQuery[len], 2048-len,"WHERE username = '%s'", g_szTempName[id])
		
		SQL_ThreadQuery(g_SqlTuple,"updateTableStatsThread", szQuery)
	}
}

public updateTableStatsThread(FailState,Handle:Query,Error[],Errcode,Data[],DataSize)
{
	// lots of error checking
	if(FailState == TQUERY_CONNECT_FAILED)
		return set_fail_state("Could not connect to SQL database.")
	else if(FailState == TQUERY_QUERY_FAILED)
		return set_fail_state("Query failed.")
	
	if(Errcode)
		return log_amx("Error on query: %s",Error)
	
	return PLUGIN_CONTINUE
}

public menuBank(id)
{	
	if(g_LoggedIn[id] && is_valid_player(id))
	{
		new title[100]
		
		formatex(title, 99, "[Bank \yAmmopacks :\r %i\w]", g_AP[id])
		
		
		new bankMenu = menu_create(title, "menuBankHandler")
		
		menu_additem(bankMenu, "\wTake Amount", "1")
		menu_additem(bankMenu, "\wTake All^n", "2")
		
		menu_additem(bankMenu, "\wSave Amount", "3")
		menu_additem(bankMenu, "\wSave All^n", "4")
		
		menu_additem(bankMenu, "\wDonate Amout^n^n", "5")
		
		
		menu_display(id, bankMenu, 0)
	}
	else client_print(id, print_chat, "[Login] You are not logged in. Say: /login if you want to login!")
	
	return PLUGIN_HANDLED;
}

public menuBankHandler(id, menu, item)
{		
	new data[6], iName[64], access, callback
	menu_item_getinfo(menu, item, access, data, 5, iName, 63, callback)
	
	new key = str_to_num(data)
	
	switch(key)
	{
		case 1:
		{
			client_cmd(id, "messagemode takeAmount")
		}
		case 2:
		{
			cmdTakeAll(id)
		}
		case 3:
		{
			client_cmd(id, "messagemode saveAmount")
		}
		case 4:
		{
			cmdSaveAll(id)
		}
		case 5:
		{
			menuDonate(id)
		}
	}
}

public cmdTakeAmount(id)
{
	if(!g_LoggedIn[id]) return PLUGIN_HANDLED
	new szAps[11]
	read_args(szAps, 10)
	remove_quotes(szAps)
	
	if(equal(szAps, "") || equal(szAps, " "))
		return PLUGIN_HANDLED
	
	new iAps = str_to_num(szAps)
	
	if(iAps < 1) return PLUGIN_HANDLED
	
	new iApsSum = iAps + zp_get_user_ammo_packs(id)
	
	if(iAps <= g_AP[id] && iApsSum <= 999)
	{
		zp_set_user_ammo_packs(id, iApsSum)
		g_AP[id] -= iAps
		
		client_print(id, print_chat, "[Bank] You took %i Ammopacks from Your Bank. Now you have %i Ammopacks in your Bank.", iAps, g_AP[id])
		
		return PLUGIN_CONTINUE
	}
	else
	{
		client_print(id, print_chat, "[Bank] You dont have enough Ammopacks or you wanted to take too much Ammopacks.")
	}
	
	return PLUGIN_CONTINUE
}

public cmdTakeAll(id)
{
	new iApsSum = zp_get_user_ammo_packs(id) + g_AP[id]
	
	if(iApsSum <= 999)
	{
		zp_set_user_ammo_packs(id, iApsSum)
		
		client_print(id, print_chat, "[Bank] You took all %i Ammopacks from your Bank.", g_AP[id])
		
		g_AP[id] = 0
	}
	else if(iApsSum > 999)
	{
		new giveAps = 999 - zp_get_user_ammo_packs(id)
		
		if(giveAps <= g_AP[id])
		{
			zp_set_user_ammo_packs(id, giveAps + zp_get_user_ammo_packs(id))
			g_AP[id] -= giveAps
			
			client_print(id, print_chat, "[Bank] You took %i Ammopacks from your Bank. Now you have %i Ammopacks in your Bank.", giveAps, g_AP[id])
		}
	}
}

public cmdSaveAmount(id)
{
	if(!g_LoggedIn[id]) return PLUGIN_HANDLED
	new szAps[11]
	read_args(szAps, 10)
	remove_quotes(szAps)
	
	if(equal(szAps, "") || equal(szAps, " "))
		return PLUGIN_HANDLED
	
	new iAps = str_to_num(szAps)
	
	if(iAps < 1) return PLUGIN_HANDLED
	
	new haveAps = zp_get_user_ammo_packs(id)
	
	if(iAps <= haveAps)
	{
		zp_set_user_ammo_packs(id, haveAps - iAps)
		g_AP[id] += iAps
		
		client_print(id, print_chat, "[Bank] You saved %i Ammopacks in your Bank. Now you have %i Ammopacks in your Bank.", iAps, g_AP[id])
	}
	else
	{
		client_print(id, print_chat, "[Bank] You dont have enough Ammopacks")
	}
	
	return PLUGIN_CONTINUE
}

public cmdSaveAll(id)
{
	new haveAps = zp_get_user_ammo_packs(id)
	
	zp_set_user_ammo_packs(id, 0)
	g_AP[id] += haveAps
	
	client_print(id, print_chat, "[Bank] You saved %i Ammopacks to your Bank. Now you have %i Ammopackt in your Bank.", haveAps, g_AP[id])
}

public menuDonate(id)
{
	new DonateMenu = menu_create("\rChoose A player to Donate:", "menuDonateHandler")
	
	new players[32], pnum, tempid
	
	new szName[32], szTempid[10]
	
	get_players(players, pnum)
	
	for( new i; i<pnum; i++ )
	{
		tempid = players[i]
		
		if(id != tempid)
		{
			get_user_name(tempid, szName, 31)
			num_to_str(tempid, szTempid, 9)
			
			menu_additem(DonateMenu, szName, szTempid, 0)
		}
	}
	
	menu_display(id, DonateMenu, 0)
}

public menuDonateHandler(id, menu, item)
{	
	new data[6], iName[64];
	new access, callback;
	menu_item_getinfo(menu, item, access, data,5, iName, 63, callback);
	
	new tempid = str_to_num(data);
	
	g_DonateID[id] = tempid
	
	client_cmd(id, "messagemode donate")
	
	menu_destroy(menu);
	return PLUGIN_HANDLED;
}

public cmdDonate(id)
{
	if(!g_LoggedIn[id] && g_DonateID[id] == 0) return PLUGIN_HANDLED
	
	new szAps[11]
	read_args(szAps, 10)
	remove_quotes(szAps)
	
	if(equal(szAps, "") || equal(szAps, " "))
		return PLUGIN_HANDLED
	
	new iAps = str_to_num(szAps)
	
	if(iAps < 1) return PLUGIN_HANDLED
	
	if(iAps <= g_AP[id])
	{
		// Take iAps away
		g_AP[id] -= iAps
		
		new NameDonate[45]
		get_user_name(g_DonateID[id], NameDonate, 44)
		new Name[45]
		get_user_name(g_DonateID[id], Name, 44)
		
		client_print(id, print_chat, "[Bank] You donated %i Ammopacks to %s. Now you have %i ammopacks in your Bank.", iAps, NameDonate, g_AP[id])
		
		// give iAps to Donateid
		g_AP[g_DonateID[id]] += iAps
		client_print(g_DonateID[id], print_chat, "[Bank] %s donated %i Ammopacks to you. Now you have %i Ammopacks in your Bank.", Name, iAps, g_AP[g_DonateID[id]])
	}
	else
	{
		client_print(id, print_chat, "[Bank] You dont have enough Ammopacks")
	}
	
	return PLUGIN_CONTINUE
}

public plugin_end()
{
	SQL_FreeHandle(g_SqlTuple)
}